// Demo 6

// Java Arithmetic Operators Applet Demo
//
//   by Charles W. Neville, 1998
//   Copyright Charles W. Neville, 1998
//
// Based in part on Deitel and Deitel's Comparison class.

// Illustrates arithmetic operators
//   + (plus), - (minus),
//   * (times), / (divide), % (remainder or modulus)
//
//  User enters two integers, say x and y, in two TextFields, presses
//  Enter key after entering second integer, and applet computes and
//  displays x + y, x - y, x*y, x/y, and x%y on Applet Panel.

import java.awt.*;
import java.awt.event.*;  // have to import Java's AWT event classes so
                          // Java will know what an ActionListener and an
                          // ActionEvent are.

import java.applet.Applet;

public class ArithOpsApplet extends Applet implements ActionListener {

   // implements ActionListener simply means that we have defined
   // a method named actionPerformed(ActionEvent e).  We will also
   // register this object as an ActionListener for the second TextField
   // (see below).  This way, when an ActionEvent happens in the second 
   // TextField, that is when the Enter key is pressed while the cursor is
   // there, an actionPerformed message will be sent to this object.  We
   // will respond by carrying out the actionPerformed method to process
   // the user's input.

   Label promptA;     // prompt for first TextField
   TextField inputA;  // where user types first number
   Label promptB;     // prompt for second TextField
   TextField inputB;  // where user types second number

   int a, b;  // a and b will hold integer equivalents of numbers
              // the user types in as strings in TextFields inputA
              // and inputB.

   int answer;  // the answer to numeric computations.

   // Applets always have an init() method which is called by
   //    the Java run-time system when the applet is first loaded.
   // init() is a good place to do initializations.
   public void init() {

      // Create a new instance of the Label class (a new Label object)
      //   which displays the String "Enter an integer", and make
      //   promptA refer to this Label object.
      promptA = new Label("Enter an integer");

      // Create a new instance of the TextField class (a new TextField
      //   object) 9 characters wide, and make inputA refer to this
      //   TextField object.
      inputA = new TextField(9);

      // Do the same for promptB and inputB.
      promptB = new Label("Enter an integer and press Enter");
      inputB = new TextField(9);

      // Add the Labels and TextFields to the Applet Panel
      add(promptA);
      add(inputA);
      add(promptB);
      add(inputB);

      // Register this object as the ActionListener (ActionEvent processor)
      //   for inputB.  (An action event happens, for example, when the
      //   Enter key is pressed.  Leaving this out causes your applet not to
      //   respond when the user presses the Enter key.
      inputB.addActionListener(this);  // this is a keyword referring to
                                       // the current object, ie. this object. 

      // initialize numeric variables
      //   (we could also have initialized them in the declarations).
      a = 0;  b = 0;  answer = 0;
   }

   // We will actually do the computations in paint just before we
   //   draw the answers on the Applet panel
   public void paint( Graphics g ) {

      answer = a + b;  // here + is addition because a and b are ints
      g.drawString(a + " + " + b + " = " + answer, 25, 140);
                                 // here + is String concatenation
                                 // everything is a String (drawString
                                 // sensibly converts ints to Strings).

      answer = a - b;  // note reuse of variable answer.  Efficiency!
      g.drawString(a + " - " + b + " = " + answer, 25, 160);

      answer = a*b;
      g.drawString(a + " * " + b + " = " + answer, 25, 180);

      if (b != 0) {
         answer = a/b;
         g.drawString(a + " / " + b + " = " + answer, 25, 200);
      }
      else {
         answer = 0;
         g.drawString(a + " / " + b + " = ?", 25, 200);
      }
      g.drawString("Note how / gives the integer quotient", 100, 200);

      if (b != 0) {
         answer = a%b;
         g.drawString(a + " % " + b + " = " + answer, 25, 220);
      }
      else {
         answer = 0;
         g.drawString(a + " % " + b + " = ?", 25, 220);
      }
      g.drawString("Note how % gives the integer remainder", 100, 220);
   }

   // This method is what we guarantee to implement when we declare that
   // we implement the ActionListener interface.  When the user presses the
   // Enter key while the cursor is in the inputB TextField, an
   // actionPerformed message will be sent to us.  We will respond by
   // carrying out (running the code in) our actionPerformed method.  We
   // could put any code in here we want, but since we want to convert
   // the user's String input to ints so we can do arithmetic on them,
   // that is what we shall do.  As explained above, we will do the
   // actual calculations in the paint method.
   public void actionPerformed( ActionEvent e ) {

       a = Integer.parseInt(inputA.getText());  // convert String contents
                                          // of inputA TextField to an int.

       b = Integer.parseInt(inputB.getText());

       // force Applet Panel to be repainted so results will be painted.
       repaint();
   }
}